#include <stdint.h>
#include <memory.h>
#include <multiboot.h>

void framebuffer_init(struct fbinfo *fbinfo)
{
    size_t fb_size = fbinfo->framebuffer_pitch * (fbinfo->framebuffer_height+1);
    uintptr_t fb_end = fbinfo->framebuffer_addr + fb_size;

    for(uintptr_t p = fbinfo->framebuffer_addr; p < fb_end; p += PAGE_SIZE)
    {
        vmm_set_page(kernel_P4, (uint64_t)P2V(p), p, PAGE_WRITE | PAGE_PRESENT);
    }

    uint8_t *fb = P2V(fbinfo->framebuffer_addr);

    for(uint32_t y = 0; y < 1; y++)
    {
        for(uint32_t x = 0; x < fbinfo->framebuffer_width; x++)
        {
            unsigned int bpp = fbinfo->framebuffer_bpp/8;
            unsigned int loc = \
                y*fbinfo->framebuffer_pitch + \
                x*(bpp);
            fb[loc++] = 0xFF;
            fb[loc++] = 0;
            fb[loc] = 0xFF;
        }
    }

}